Public Class Label3D
    Inherits System.Windows.Forms.UserControl

#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call
        mText = "Label3D"
        mAlignment = Align.CenterMiddle
        mEffect = Effect3D.Raised
        SetStyle(ControlStyles.ResizeRedraw, "True")
        setstyle(ControlStyles.SupportsTransparentBackColor, True)
        Me.BackColor = Color.Transparent
        Me.Font = New Font(Me.Font.Name, 14, FontStyle.Bold)
    End Sub

    'UserControl1 overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        '
        'Label3D
        '
        Me.Name = "Label3D"

    End Sub

#End Region
    Public Enum Align
        TopLeft
        TopMiddle
        TopRight
        CenterLeft
        CenterMiddle
        CenterRight
        BottomLeft
        BottomMiddle
        BottomRight
    End Enum
    Public Enum Effect3D
        None '  
        Raised ' 
        RaisedHeavy '  
        Carved ' 
        CarvedHeavy '  
    End Enum

    Public Event AlignmentChanged(ByVal sender As Object, ByVal ev _
    As EventArgs)
    Public Event EffectChanged(ByVal sender As Object, ByVal ev As EventArgs)
    Public Event Text3DChanged(ByVal sender As Object, ByVal ev As EventArgs)

    Private Shared mAlignment As Align
    Private Shared mEffect As Effect3D
    Public Property Alignment() As Align
        Get
            Alignment = mAlignment
        End Get
        Set(ByVal Value As Align)
            mAlignment = Value
            Invalidate()
            RaiseEvent AlignmentChanged(Me, New EventArgs())
        End Set
    End Property

    Public Property Effect() As Effect3D
        Get
            Effect = mEffect
        End Get
        Set(ByVal Value As Effect3D)
            mEffect = Value
            Invalidate()
            RaiseEvent EffectChanged(Me, New EventArgs())
        End Set
    End Property
    Private mText As String
    Property Text3d() As String
        Get
            Text3d = mText
        End Get

        Set(ByVal Value As String)
            mText = Value
            Invalidate()
            RaiseEvent Text3DChanged(Me, New EventArgs())
        End Set
    End Property


    Protected Overrides Sub OnPaint(ByVal e As PaintEventArgs)
        Dim lblFont As Font = Me.Font
        Dim lblBrush As New SolidBrush(Color.Red)
        Dim X, Y As Integer
        '       
        Dim TextSize As SizeF = e.Graphics.MeasureString(mText, lblFont)
        Select Case Me.mAlignment
            Case Align.BottomLeft '      
                X = 2 '    
                Y = Me.Height - TextSize.Height
            Case Align.BottomMiddle '     
                X = CInt((Me.Width - TextSize.Width) / 2)
                Y = Me.Height - TextSize.Height
            Case Align.BottomRight '      
                X = Me.Width - TextSize.Width - 2
                Y = Me.Height - TextSize.Height
            Case Align.CenterLeft '     
                X = 2
                Y = (Me.Height - TextSize.Height) / 2
            Case Align.CenterMiddle '     
                X = (Me.Width - TextSize.Width) / 2
                Y = (Me.Height - TextSize.Height) / 2
            Case Align.CenterRight '     
                X = Me.Width - TextSize.Width - 2
                Y = (Me.Height - TextSize.Height) / 2
            Case Align.TopLeft '     
                X = 2
                Y = 2
            Case Align.TopMiddle '     
                X = (Me.Width - TextSize.Width) / 2
                Y = 2
            Case Align.TopRight '     
                X = Me.Width - TextSize.Width - 2
                Y = 2
        End Select
        '             
        Dim dispX, dispY As Integer
        Select Case mEffect
            Case Effect3D.None
                dispX = 0 : dispY = 0
            Case Effect3D.Raised
                dispX = 1 : dispY = 1
            Case Effect3D.RaisedHeavy
                dispX = 2 : dispY = 2
            Case Effect3D.Carved
                dispX = -1 : dispY = -1
            Case Effect3D.CarvedHeavy
                dispX = -2 : dispY = -2
        End Select
        '      ɡ    
        'e.Graphics.Clear(Me.BackColor)
        '    
        lblBrush.Color = Color.White
        e.Graphics.DrawString(mText, lblFont, lblBrush, X, Y)
        '      ϡ        
        lblBrush.Color = Me.ForeColor
        e.Graphics.DrawString(mText, lblFont, lblBrush, X + dispX, Y + dispY)
    End Sub

End Class
Public Class PropertyChangedEvent
    Inherits EventArgs
    Public Shared ReadOnly OldValue As Object

End Class
