Imports System.Drawing.Drawing2D
Public Class RoundButton
    Inherits System.Windows.Forms.UserControl

#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call
        SetStyle(ControlStyles.ResizeRedraw, "True")
    End Sub

    'UserControl1 overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        '
        'RoundButton
        '
        Me.Name = "RoundButton"

    End Sub

#End Region
    Public Event NowPlaying()
    Public Event NowPausing()
    Private currentText As String = "Play", currentState As State
    Private Sub RoundButton_MouseEnter(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.MouseEnter
        If currentState = State.Active Then
            Me.BackColor = Color.Green
            currentText = "Play"
            RaiseEvent NowPlaying()
        End If
    End Sub
    Private Sub RoundButton_MouseLeave(ByVal sender As Object, _
    ByVal e As System.EventArgs) Handles MyBase.MouseLeave
        If currentState = State.Active Then
            Me.BackColor = Color.Red
            currentText = "Pause"
            RaiseEvent NowPausing()
        End If
    End Sub
    Protected Overrides Sub OnPaint(ByVal e As PaintEventArgs)
        Dim roundPath As New GraphicsPath()
        Dim R As New Rectangle(0, 0, Me.Width, Me.Height)
        Dim G As Graphics = Me.CreateGraphics
        roundPath.AddEllipse(R)
        Me.Region = New Region(roundPath)
        G.DrawEllipse(New Pen(Color.DarkGray, 3), R)


        Dim fnt As Font
        If currentState = State.Active Then
            If Me.BackColor.Equals(Color.Silver) Then Me.BackColor = Color.Green
            fnt = New Font("Verdana", 24, FontStyle.Bold)
        Else
            fnt = New Font("Verdana", 14, FontStyle.Regular)
        End If
        Dim X As Integer = (Me.Width - G.MeasureString( _
        currentText, fnt).Width) / 2
        Dim Y As Integer = (Me.Height - G.MeasureString( _
        currentText, fnt).Height) / 2
        G.DrawString(currentText, fnt, Brushes.White, X, Y)
    End Sub
    Public Enum State
        Active
        Inactive
    End Enum
    Private Sub RoundButton_Click(ByVal sender As Object, _
    ByVal e As System.EventArgs) Handles MyBase.Click
        If currentState = State.Active Then
            currentState = State.Inactive
            Me.BackColor = Color.Silver
            currentText = "Resume"
        Else
            currentState = State.Active
            currentText = "Play"
        End If
        Me.Invalidate()
    End Sub

End Class
