Public Class frmMain
    Inherits System.Windows.Forms.Form

    Private c3DEngine As CSampleGraphicsEngine
    Private bRunning As Boolean = False
#Const RENDER_WINDOWED = 1

#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call

    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Dim resources As System.Resources.ResourceManager = New System.Resources.ResourceManager(GetType(frmMain))
        '
        'frmMain
        '
        Me.AutoScale = False
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.BackColor = System.Drawing.Color.Black
        Me.ClientSize = New System.Drawing.Size(576, 292)
        Me.ControlBox = False
        Me.Icon = CType(resources.GetObject("$this.Icon"), System.Drawing.Icon)
        Me.MaximizeBox = False
        Me.MinimizeBox = False
        Me.MinimumSize = New System.Drawing.Size(400, 300)
        Me.Name = "frmMain"
        Me.SizeGripStyle = System.Windows.Forms.SizeGripStyle.Hide
        Me.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen
        Me.Text = "Simple Direct3D9 (DirectX4VB.com)"
        Me.WindowState = System.Windows.Forms.FormWindowState.Maximized

    End Sub

#End Region

    Private Sub frmMain_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Try
            Me.Size = New Drawing.Size(400, 300)
            Me.MaximumSize = New Drawing.Size(400, 300)
            Me.MinimumSize = New Drawing.Size(400, 300)

            Me.Show()
            Application.DoEvents()

#If RENDER_WINDOWED Then

            'create the engine:
            c3DEngine = New CSampleGraphicsEngine(Me)

#Else

            'run through 4 modes and choose the best.
            'it is more common to present a list of available modes to
            'the user, but for simplicity we wont do this.
            dim iW as Integer = 0, iH as Integer = 0, iD as Integer = 0
            If CSampleGraphicsEngine.isDisplayModeOkay(1024, 768, 32) Then
                iW = 1024 : iH = 768 : iD = 32
            ElseIf (CSampleGraphicsEngine.isDisplayModeOkay(1024, 768, 16)) Then
                iW = 1024 : iH = 768 : iD = 16
            ElseIf (CSampleGraphicsEngine.isDisplayModeOkay(640, 480, 32)) Then
                iW = 640 : iH = 480 : iD = 32
            ElseIf (CSampleGraphicsEngine.isDisplayModeOkay(640, 480, 16)) Then
                iW = 640 : iH = 480 : iD = 16
            Else
                'no modes supported?!
                Throw New Exception("No supported display modes found")
            End If

            c3DEngine = New CSampleGraphicsEngine(Me, iW, iH, iD)

#End If

            'set the initial properties for the engine
            c3DEngine.backFaceCulling = False
            c3DEngine.drawFrameRate = True
            c3DEngine.useTextures = True
            c3DEngine.wireframe = False

            'as soon as this turns to false we bail out
            'and exit the program
            bRunning = True

            'the main core loop.
            Do While bRunning
                'these two functions do all the work,
                c3DEngine.oneFrameUpdate()
                c3DEngine.oneFrameRender()
                Application.DoEvents()
            Loop

            'if we've left the loop then the application has
            'finished - but we need to make sure the form is
            'unloaded.
            c3DEngine = Nothing
            End

            'a catch-all error trap
        Catch err As Exception
            MsgBox(err.ToString)
            End
        End Try

    End Sub

    Protected Overrides Sub OnKeyDown(ByVal e As System.Windows.Forms.KeyEventArgs)
        Select Case e.KeyCode
            Case Keys.Escape
                bRunning = False
            Case Keys.F1
                c3DEngine.wireframe = Not c3DEngine.wireframe
            Case Keys.F2
                c3DEngine.useTextures = Not c3DEngine.useTextures
            Case Keys.F3
                c3DEngine.backFaceCulling = Not c3DEngine.backFaceCulling
            Case Keys.F4
                c3DEngine.drawFrameRate = Not c3DEngine.drawFrameRate
        End Select
    End Sub
End Class
